=== debian/changelog ===
quassel (1:0.10.0-2.3+deb8u4) jessie-security; urgency=high

  * Backport upstream commit to implement a custom deserializer.
    Fixes possible remote code execution. (Closes: #896914)
  * Backport upstream commit to reject client logins before the core is
    configured. Fixes a DoS vulnerability. (Closes: #896915)

 -- Felix Geyer <fgeyer@debian.org>  Sat, 28 Apr 2018 11:54:10 +0200

quassel (1:0.10.0-2.3+deb8u3) jessie; urgency=medium

  * Non-maintainer upload.
  * Fix CVE-2016-4414: remote DoS in quassel core with invalid handshake data.
    (Closes: #826402)
    - Add debian/patches/CVE-2016-4414.patch, cherry-picked from upstream.

 -- Pierre Schweitzer <pierre@reactos.org>  Sun, 05 Jun 2016 12:41:35 +0200

quassel (1:0.10.0-2.3+deb8u2) jessie; urgency=high

  * Non-maintainer upload.
  * Fix CVE-2015-8547: remote DoS in quassel core, using /op * command.
    (Closes: #807801)
    - Add debian/patches/CVE-2015-8547.patch, cherry-picked from upstream.

 -- Pierre Schweitzer <pierre@reactos.org>  Sun, 13 Dec 2015 11:04:05 +0100

quassel (1:0.10.0-2.3+deb8u1) jessie-security; urgency=high

  * Fix CVE-2015-3427: SQL injection vulnerability in PostgreSQL backend.
    (Closes: #783926)
    - Add debian/patches/CVE-2015-3427.patch, cherry-picked from upstream.
    - The original issue was CVE-2013-4422 which had an incomplete fix.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 10 May 2015 16:41:30 +0200

quassel (1:0.10.0-2.3) unstable; urgency=high

  * Non-maintainer upload with maintainer's permission.
  * Improve the message-splitting algorithm for PRIVMSG and CTCP.  Original
    patch from Michael Marley, backported by Steinar H. Gunderson.  Fixes
    CVE-2015-2778 and CVE-2015-2779.  (Closes: #781024)

 -- Olly Betts <olly@survex.com>  Wed, 01 Apr 2015 11:41:28 +1300

quassel (1:0.10.0-2.2) unstable; urgency=high

  * Non-maintainer upload.
  * Increment Debian revision and epoch to re-upload 0.10.0-2.1 to
    unstable containing the fix for #766962 / CVE-2014-8483:
    out-of-bounds read in ECB Blowfish decryption.

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 08 Nov 2014 14:14:56 +0100

quassel (0.10.0-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * Add CVE-2014-8483.patch patch.
    CVE-2014-8483: out-of-bounds read in ECB Blowfish decryption.
    (Closes: #766962)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 02 Nov 2014 19:10:58 +0100

quassel (0.10.0-2) unstable; urgency=low

  * Fixing security issue where quassel core certificate is 
    readable by all local users
    - Change permissions of /var/lib/quassel/quasselCert.pem
    - Add debian/NEWS to notify the admin to change the certificate

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Fri, 04 Jul 2014 17:15:10 +0200

quassel (0.10.0-1) unstable; urgency=low

  * New upstream release
  * Debian policy to 3.9.5
  * Don't create 1024 bit key (Closes: #732728)
  * Start quaselcore after databases (Closes: #701943)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Fri, 09 May 2014 17:42:19 +0200

quassel (0.9.2-1) unstable; urgency=low

  * New upstream release
  * Increase debhelper compat to 9 - supporting hardening now

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Tue, 26 Nov 2013 22:53:55 +0100

quassel (0.9.1-1) unstable; urgency=low

  * New upstream release

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Tue, 05 Nov 2013 17:39:26 +0100
