## quassel 0.10.1

=== debian/changelog ===
quassel (0.10.1-0ubuntu1) utopic; urgency=medium

  * New upstream bugfix release

 -- Scott Kitterman <scott@kitterman.com>  Thu, 25 Sep 2014 00:19:27 -0400

quassel (0.10.0-0ubuntu2) trusty; urgency=medium

  * Update quasselcore man page to cover all usage options

 -- Scott Kitterman <scott@kitterman.com>  Wed, 09 Apr 2014 16:10:10 -0400

quassel (0.10.0-0ubuntu1) trusty; urgency=medium

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Tue, 25 Mar 2014 23:53:39 +0000

quassel (0.10~rc1-0ubuntu1) trusty; urgency=medium

  * New upstream RC release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Sun, 16 Mar 2014 17:49:07 +0000

quassel (0.10~beta1-0ubuntu1) trusty; urgency=low

  * New upstream beta relase
    - Drop debian/patches/upstream_fix_fullscreen_mode.diff which had been
      cherrypicked from upstream

 -- Scott Kitterman <scott@kitterman.com>  Tue, 18 Feb 2014 23:18:25 -0500

quassel (0.9.2-0ubuntu4) trusty; urgency=medium

  * Cherry pick upstream commit 47a6910aed00018c7230cc2cc90ae8e80fa77dda
    as upstream_fix_fullscreen_mode.diff to fix UI breakage when toggling
    fullscreen mode

 -- Philip Muškovac <yofel@kubuntu.org>  Mon, 23 Dec 2013 01:03:22 +0100

quassel (0.9.2-0ubuntu3) trusty; urgency=low

  * Revert addition of conflict relations between quassel-data and
    quassel-qt4-data, as the packages are usually installed at the same time
    and do not ship common files. (LP: #1257592)

 -- Luke Faraone <lfaraone@ubuntu.com>  Wed, 04 Dec 2013 00:34:49 -0500

quassel (0.9.2-0ubuntu2) trusty; urgency=low

  * Add quasselcore upstart job. Thanks to Michael Marley. (LP: #1244036)
  * Restart quasselcore after upgrades.
  * Make quassel-data and quassel-qt4-data conflict as they ship common files.

 -- Felix Geyer <debfx@ubuntu.com>  Mon, 02 Dec 2013 16:50:58 +0100

quassel (0.9.2-0ubuntu1) trusty; urgency=low

  * New upstream release
    - Includes fix for cross-user data exposure in the core (LP: #1255362)

 -- Scott Kitterman <scott@kitterman.com>  Tue, 26 Nov 2013 19:56:06 -0500
